Index: trunk/src/VBox/Additions/WINNT/VBoxService/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/Makefile.kmk	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/Makefile.kmk	(revision 11982)
@@ -7,15 +7,6 @@
 # Copyright (C) 2008 Sun Microsystems, Inc.
 #
-# This file is part of VirtualBox Open Source Edition (OSE), as
-# available from http://www.virtualbox.org. This file is free software;
-# you can redistribute it and/or modify it under the terms of the GNU
-# General Public License (GPL) as published by the Free Software
-# Foundation, in version 2 as it comes in the "COPYING" file of the
-# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
+# Sun Microsystems, Inc. confidential
+# All rights reserved
 #
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.cpp	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.cpp	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2008 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.rc
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.rc	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxService.rc	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2008 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxUtils.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxUtils.cpp	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxUtils.cpp	(revision 11982)
@@ -8,15 +8,6 @@
  * Copyright (C) 2006-2008 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxUtils.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxUtils.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxUtils.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2008 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfo.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfo.cpp	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfo.cpp	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfo.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfo.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfo.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoAdditions.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoAdditions.cpp	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoAdditions.cpp	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoAdditions.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoAdditions.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoAdditions.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoNet.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoNet.cpp	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoNet.cpp	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoNet.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoNet.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoNet.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoOS.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoOS.cpp	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoOS.cpp	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoOS.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoOS.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoOS.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoUser.cpp
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoUser.cpp	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoUser.cpp	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoUser.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoUser.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/VBoxVMInfoUser.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 
Index: trunk/src/VBox/Additions/WINNT/VBoxService/resource.h
===================================================================
--- trunk/src/VBox/Additions/WINNT/VBoxService/resource.h	(revision 11958)
+++ trunk/src/VBox/Additions/WINNT/VBoxService/resource.h	(revision 11982)
@@ -7,15 +7,6 @@
  * Copyright (C) 2006-2007 Sun Microsystems, Inc.
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
+ * Sun Microsystems, Inc. confidential
+ * All rights reserved
  */
 