Index: /trunk/Config.kmk
===================================================================
--- /trunk/Config.kmk	(revision 12449)
+++ /trunk/Config.kmk	(revision 12450)
@@ -188,4 +188,6 @@
 # Use additions from the build server.
 #VBOX_WITH_ADDITIONS_FROM_BUILD_SERVER = 1
+# Include additions in the package
+VBOX_WITH_ADDITIONS_PACKING = 1
 # Don't bother with additions, overrides VBOX_WITH_ADDITIONS.
 # This is not used by makefiles, only Config.kmk, see below.
@@ -210,4 +212,6 @@
 # Use documentation from the build server.
 #VBOX_WITH_DOCS_FROM_BUILD_SERVER = 1
+# Include documentation in the package
+VBOX_WITH_DOCS_PACKING = 1
 # Don't bother with documentation, overrides VBOX_WITH_DOCS.
 # This is not used by makefiles, only Config.kmk, see below.
@@ -554,4 +558,5 @@
  VBOX_WITH_DEBUGGER_GUI=
  VBOX_WITH_WIN32_ADDITIONS_SHAREDFOLDERS=
+ VBOX_WITH_ADDITIONS_PACKING=
  VBOX_WITHOUT_ADDITIONS_ISO=1
  VBOX_WITH_OS2_ADDITIONS_BIN=
@@ -559,4 +564,5 @@
  VBOX_WITH_KCHMVIEWER=
  VBOX_WITH_DOCS=
+ VBOX_WITH_DOCS_PACKING=
  VBOX_WITH_TESTSUITE=
  VBOX_WITH_INTEL_PXE=
Index: /trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 12449)
+++ /trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 12450)
@@ -125,6 +125,8 @@
 
 # Guest Additions
-LINUXNOSTRIP += \
-	$(if $(VBOX_OSE),,additions/VBoxGuestAdditions.iso)
+ifdef VBOX_WITH_ADDITIONS_PACKING
+ LINUXNOSTRIP += \
+ 	$(if $(VBOX_OSE),,additions/VBoxGuestAdditions.iso)
+endif
 
 # Shared Folders
@@ -142,5 +144,5 @@
 	$(if $(VBOX_WITH_GUEST_PROPS),VBoxGuestPropSvc.so)
 
-ifdef VBOX_WITH_DOCS
+ifdef VBOX_WITH_DOCS_PACKING
  LINUXNOSTRIP += \
 	UserManual.pdf
Index: /trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 12449)
+++ /trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 12450)
@@ -155,7 +155,7 @@
 	  nls/VirtualBox_$(f).qm nls/qt_$(f).qm),)
 
-ifdef VBOX_WITH_DOCS
-  SOLARIS_NO_STRIP += \
-	UserManual.pdf
+ifdef VBOX_WITH_DOCS_PACKING
+ SOLARIS_NO_STRIP += \
+ 	UserManual.pdf
 endif
 
@@ -188,6 +188,8 @@
 
 # Guest Additions
-SOLARIS_NO_STRIP += \
-	$(if $(VBOX_OSE),,additions/VBoxGuestAdditions.iso)
+ifdef VBOX_WITH_ADDITIONS_PACKING
+ SOLARIS_NO_STRIP += \
+ 	additions/VBoxGuestAdditions.iso
+endif
 
 SOLARIS_ARCH_FILES := \
@@ -242,5 +244,5 @@
 	$(QUIET)$(if $(VBOX_WITH_QT4GUI),$(MKDIR) -p $(SOLARIS_INST_DIR)/nls,)
 	$(QUIET)$(if $(and $(VBOX_WITH_QT4GUI), $(not $(VBOX_WITH_SEPARATE_SDK))),$(MKDIR) -p $(SOLARIS_INST_DIR)/nls,)
-	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(PATH_BIN)/additions/VBoxGuestAdditions.iso               $(SOLARIS_INST_DIR)/additions/VBoxGuestAdditions.iso)
+	$(QUIET)$(if $(VBOX_WITH_ADDITIONS_PACKING),$(INSTALL) -m 0644 $(PATH_BIN)/additions/VBoxGuestAdditions.iso               $(SOLARIS_INST_DIR)/additions/)
 	$(QUIET)$(if $(VBOX_WITH_VRDP_RDESKTOP),$(MKDIR) -p $(SOLARIS_INST_DIR)/rdesktop-vrdp-keymaps,)
 	$(QUIET)$(INSTALL) -m 0644 $(PATH_BIN)/vboxdrv                                                          $(SOLARIS_INST_DIR)/vboxdrv
@@ -359,5 +361,5 @@
 	$(QUIET)$(INSTALL) -m 0644 $(PATH_ROOT)/src/VBox/HostDrivers/Support/solaris/vboxdrv.conf               $(SOLARIS_INST_DIR)/vboxdrv.conf
 	$(QUIET)$(INSTALL) -m 0644 $(PATH_ROOT)/src/VBox/HostDrivers/VBoxNetFlt/solaris/vboxflt.conf            $(SOLARIS_INST_DIR)/vboxflt.conf
-	$(QUIET)$(if $(VBOX_WITH_DOCS),$(INSTALL) -m 0644 $(PATH_BIN)/UserManual.pdf                            $(SOLARIS_INST_DIR)/UserManual.pdf,)
+	$(QUIET)$(if $(VBOX_WITH_DOCS_PACKING)),$(INSTALL) -m 0644 $(PATH_BIN)/UserManual.pdf  $(SOLARIS_INST_DIR)/)
 	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(PATH_BIN)/LICENSE                                        $(SOLARIS_INST_DIR)/LICENSE)
 	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(PATH_BIN)/LICENSE                                        $(SOLARIS_INST_DIR)/vbox.copyright)